<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<title>GNU SASL API Reference Manual</title>
<meta name="generator" content="DocBook XSL Stylesheets V1.76.1">
<link rel="home" href="index.html" title="GNU SASL API Reference Manual">
<link rel="up" href="index.html" title="GNU SASL API Reference Manual">
<link rel="prev" href="index.html" title="GNU SASL API Reference Manual">
<link rel="next" href="gsasl-gsasl.html" title="gsasl">
<meta name="generator" content="GTK-Doc V1.18 (XML mode)">
<link rel="stylesheet" href="style.css" type="text/css">
</head>
<body bgcolor="white" text="black" link="#0000FF" vlink="#840084" alink="#0000FF">
<table class="navigation" id="top" width="100%" summary="Navigation header" cellpadding="2" cellspacing="2"><tr valign="middle">
<td><a accesskey="p" href="index.html"><img src="left.png" width="24" height="24" border="0" alt="Prev"></a></td>
<td> </td>
<td><a accesskey="h" href="index.html"><img src="home.png" width="24" height="24" border="0" alt="Home"></a></td>
<th width="100%" align="center">GNU SASL API Reference Manual</th>
<td><a accesskey="n" href="gsasl-gsasl.html"><img src="right.png" width="24" height="24" border="0" alt="Next"></a></td>
</tr></table>
<div class="chapter">
<div class="titlepage"><div><div><h2 class="title">
<a name="intro"></a>GNU SASL API Reference Manual</h2></div></div></div>
<div class="toc"><dl>
<dt>
<span class="refentrytitle"><a href="gsasl-gsasl.html">gsasl</a></span><span class="refpurpose"></span>
</dt>
<dt>
<span class="refentrytitle"><a href="gsasl-gsasl-mech.html">gsasl-mech</a></span><span class="refpurpose"></span>
</dt>
<dt>
<span class="refentrytitle"><a href="gsasl-gsasl-compat.html">gsasl-compat</a></span><span class="refpurpose"></span>
</dt>
</dl></div>
<p>
GNU SASL is an implementation of the Simple Authentication and
Security Layer framework and a few common SASL mechanisms.  SASL is
used by network servers (e.g., IMAP, SMTP) to request authentication
from clients, and in clients to authenticate against servers.
    </p>
<p>
GNU SASL consists of a library (`libgsasl'), a command line utility
(`gsasl') to access the library from the shell, and a manual.  The
library includes support for the framework (with authentication
functions and application data privacy and integrity functions) and at
least partial support for the ANONYMOUS, CRAM-MD5, DIGEST-MD5,
EXTERNAL, GS2-KRB5, GSSAPI, LOGIN, NTLM, PLAIN, SCRAM-SHA-1,
SCRAM-SHA-1-PLUS, SAML20, OPENID20, and SECURID mechanisms.
    </p>
<p>
The library is easily ported because it does not do network
communication by itself, but rather leaves it up to the calling
application.  The library is flexible with regards to the
authorization infrastructure used, as it utilizes a callback into the
application to decide whether a user is authorized or not.
    </p>
<p>
GNU SASL is developed for the GNU/Linux system, but runs on over 20
platforms including most major Unix platforms and Windows, and many
kind of devices including iPAQ handhelds and S/390 mainframes.
    </p>
<p>
GNU SASL is written in pure ANSI C89 to be portable to embedded and
otherwise limited platforms.  The entire library, with full support
for ANONYMOUS, EXTERNAL, PLAIN, LOGIN and CRAM-MD5, and the front-end
that support client and server mode, and the IMAP and SMTP protocols,
fits in under 60kb on an Intel x86 platform, without any modifications
to the code.  (This figure was accurate as of version 0.0.13.)
    </p>
<p>
The library is licensed under the GNU Lesser General Public License
version 2.1 or later.  The command-line application (src/), examples
(examples/), self-test suite (tests/) are licensed under the GNU
General Public License license version 3.0 or later.  The
documentation (doc/) is licensed under the GNU Free Documentation
License version 1.3 or later.
    </p>
<p>
A conceptual view of how your application, the library, and each
mechanism interact is shown in <a class="xref" href="intro.html#abstraction" title="Figure 1. Illustration of separation between application and individual mechanism">Figure 1, “Illustration of separation between application and
	individual mechanism”</a>.
    </p>
<div class="figure">
<a name="abstraction"></a><p class="title"><b>Figure 1. Illustration of separation between application and
	individual mechanism</b></p>
<div class="figure-contents"><div><img src="abstraction.png" alt="Illustration of separation between application and individual mechanism"></div></div>
</div>
<br class="figure-break"><p>
      The operation of an application using the library can best be
      understood in terms of a flow chart diagram, as shown in
      <a class="xref" href="intro.html#controlflow" title="Figure 2. High-level control flow of SASL application">Figure 2, “High-level control flow of SASL application”</a>.  The details on how the actual
      negotiation are carried out are illustrated in
      <a class="xref" href="intro.html#controlflow2" title="Figure 3. Low-level control flow of SASL application">Figure 3, “Low-level control flow of SASL application”</a>.
    </p>
<div class="figure">
<a name="controlflow"></a><p class="title"><b>Figure 2. High-level control flow of SASL application</b></p>
<div class="figure-contents"><div><img src="controlflow.png" alt="High-level control flow of SASL application"></div></div>
</div>
<br class="figure-break"><div class="figure">
<a name="controlflow2"></a><p class="title"><b>Figure 3. Low-level control flow of SASL application</b></p>
<div class="figure-contents"><div><img src="controlflow2.png" alt="Low-level control flow of SASL application"></div></div>
</div>
<br class="figure-break">
</div>
<div class="footer">
<hr>
          Generated by GTK-Doc V1.18</div>
</body>
</html>